/* XPLog -- an PPP-Dialer and Phonecost Program
 * Copyright (C) 1998 Stefan Kraus
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */ 

#include "xplog.h"

const char *const month[]={_xpl_month1,_xpl_month2,_xpl_month3,_xpl_month4,_xpl_month5,_xpl_month6,_xpl_month7,_xpl_month8,_xpl_month9,_xpl_month10,_xpl_month11,_xpl_month12};

/* Preference Datas */
extern struct xplog xplogs;

/* Phonebill definition */
struct xplPhoneBill xplPB;


/* HomeDirectory */
extern char xpuser[1024];
/* String working */
extern const char *strdef;
extern char APuffer[256],BPuffer[256],CPuffer[256];

/* Filehandle */
extern FILE *fh; 

/* German CityPlus Rates */
extern float cityplus;
extern float protcity;

/* Calender Buttons */
int caldaya,calmontha,caljeara,callena;
int caldayb,calmonthb,caljearb,callenb;

/* Chart-Graphic */
double chartdat[100]; /* for 3 Month */
int chartlab[100]; /* Number of Day */
double chartonl[100]; /* Online-Time */
int chartflag;
int chartdays; 
int chartday; 
/* SNAP-Chart-Datas */
double snapcost[124];
double snaponline[124];
int snapentrys=0;
float spcost=0;
float sponline=0;
/* Chart / Snap Flag */
int statmode=0;

void phonebill(void)
{
  /* Filehandle */
  FILE *fh; 

  int a,b;

  long atime;
  struct tm atm;

  xplPB.form = fl_bgn_form(FL_UP_BOX,450,401); 

   fl_set_border_width(2);

   /* actual date */
   /* begin */
   atime = time(0);
   atm = *localtime(&atime);
   caldaya = 1;
   calmontha = atm.tm_mon+1;
   caljeara = atm.tm_year +1900;
   /* end */
   caldayb = monthLen(calmontha,caljeara);
   calmonthb = calmontha;
   caljearb = caljeara;

   /* load last Calc-Range */
   strcpy(APuffer,xpuser);
   strcat(APuffer,"/.xplog.range");
   /* read Calc-Range */
   if ((fh=fopen(APuffer,"r"))!=NULL)
     {   
       if (fgets(BPuffer,255,fh)!=NULL)
         {
           memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
           caldaya=atoi(BPuffer);
         }
       if (fgets(BPuffer,255,fh)!=NULL)
         {
           memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
           calmontha=atoi(BPuffer);
         }
       if (fgets(BPuffer,255,fh)!=NULL)
         {
           memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
           caljeara=atoi(BPuffer);
         }
       if (fgets(BPuffer,255,fh)!=NULL)
         {
           memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
           caldayb=atoi(BPuffer);
         }
       if (fgets(BPuffer,255,fh)!=NULL)
         {
           memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
           calmonthb=atoi(BPuffer);
         }
       if (fgets(BPuffer,255,fh)!=NULL)
         {
           memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);
           caljearb=atoi(BPuffer);
         }
       fclose(fh);
     }

   /* from */
   xplPB.QPLcalframea = fl_add_labelframe(FL_DOWN_FRAME,8,11,214,173,_xpl_from);
   xplPB.QPLmontha = fl_add_box(FL_DOWN_FRAME,10,16,60,24,month[calmontha-1]);
   xplPB.QPLmontham = fl_add_button(FL_NORMAL_BUTTON,70,16,24,24,"-");
   xplPB.QPLmonthap = fl_add_button(FL_NORMAL_BUTTON,94,16,24,24,"+");

   xplPB.QPLjeara = fl_add_counter(FL_NORMAL_COUNTER,120,16,100,24,"");
   fl_set_counter_value(xplPB.QPLjeara,caljeara);
   fl_set_counter_bounds(xplPB.QPLjeara,1970,2069);
   fl_set_counter_step(xplPB.QPLjeara,1,10);
   fl_set_counter_precision(xplPB.QPLjeara,0);

   xplPB.QPLdaya[1] = fl_add_box(FL_DOWN_BOX,10,42,30,18,_xpl_day1);
   fl_set_object_color(xplPB.QPLdaya[1],FL_TOMATO,0);
   xplPB.QPLdaya[2] = fl_add_frame(FL_DOWN_FRAME,42,44,26,14,_xpl_day2);
   xplPB.QPLdaya[3] = fl_add_frame(FL_DOWN_FRAME,72,44,26,14,_xpl_day3);
   xplPB.QPLdaya[4] = fl_add_frame(FL_DOWN_FRAME,102,44,26,14,_xpl_day4);
   xplPB.QPLdaya[5] = fl_add_frame(FL_DOWN_FRAME,132,44,26,14,_xpl_day5);
   xplPB.QPLdaya[6] = fl_add_frame(FL_DOWN_FRAME,162,44,26,14,_xpl_day6);
   xplPB.QPLdaya[7] = fl_add_box(FL_DOWN_BOX,190,42,30,18,_xpl_day7);
   fl_set_object_color(xplPB.QPLdaya[7],FL_TOMATO,0);

   /* to */
   xplPB.QPLcalframeb = fl_add_labelframe(FL_DOWN_FRAME,228,11,214,173,_xpl_to);
   xplPB.QPLmonthb = fl_add_box(FL_DOWN_FRAME,230,16,60,24,month[calmonthb-1]);
   xplPB.QPLmonthbm = fl_add_button(FL_NORMAL_BUTTON,290,16,24,24,"-");
   xplPB.QPLmonthbp = fl_add_button(FL_NORMAL_BUTTON,314,16,24,24,"+");

   xplPB.QPLjearb = fl_add_counter(FL_NORMAL_COUNTER,340,16,100,24,"");
   fl_set_counter_value(xplPB.QPLjearb,caljearb);
   fl_set_counter_bounds(xplPB.QPLjearb,1970,2070);
   fl_set_counter_step(xplPB.QPLjearb,1,10);
   fl_set_counter_precision(xplPB.QPLjearb,0);

   xplPB.QPLdayb[1] = fl_add_box(FL_DOWN_BOX,230,42,30,18,_xpl_day1);
   fl_set_object_color(xplPB.QPLdayb[1],FL_TOMATO,0);
   xplPB.QPLdayb[2] = fl_add_frame(FL_DOWN_FRAME,262,44,26,14,_xpl_day2);
   xplPB.QPLdayb[3] = fl_add_frame(FL_DOWN_FRAME,292,44,26,14,_xpl_day3);
   xplPB.QPLdayb[4] = fl_add_frame(FL_DOWN_FRAME,322,44,26,14,_xpl_day4);
   xplPB.QPLdayb[5] = fl_add_frame(FL_DOWN_FRAME,352,44,26,14,_xpl_day5);
   xplPB.QPLdayb[6] = fl_add_frame(FL_DOWN_FRAME,382,44,26,14,_xpl_day6);
   xplPB.QPLdayb[7] = fl_add_box(FL_DOWN_BOX,410,42,30,18,_xpl_day7);
   fl_set_object_color(xplPB.QPLdayb[7],FL_TOMATO,0);

   /* Draw Calendar */
   callena = monthLen(calmontha,caljeara);
   caldaya = docal(0,caldaya,calmontha,caljeara);
   callenb = monthLen(calmonthb,caljearb);
   caldayb = docal(1,caldayb,calmonthb,caljearb);

   xplPB.viewfield = fl_add_box(FL_DOWN_FRAME,6,188,304,28,"");
   xplPB.QPLframe = fl_add_frame(FL_DOWN_FRAME,314,190,128,24,"");
   xplPB.QPLcalc = fl_add_button(FL_NORMAL_BUTTON,316,192,40,20,_xpl_calc);
   xplPB.QPLview = fl_add_button(FL_NORMAL_BUTTON,358,192,40,20,_xpl_view);
   xplPB.QPLexit = fl_add_button(FL_NORMAL_BUTTON,400,192,40,20,_xpl_exit);

   xplPB.chart = fl_add_chart(FL_BAR_CHART,6,218,438,147,"");

   xplPB.QPLstatframe = fl_add_frame(FL_DOWN_FRAME,8,369,334,24,_xpl_statistic);
   fl_set_object_lalign(xplPB.QPLstatframe,FL_ALIGN_LEFT);
   xplPB.QPLstat = fl_add_button(FL_NORMAL_BUTTON,94,371,60,20,_xpl_stat);
   xplPB.QPLonline = fl_add_button(FL_NORMAL_BUTTON,156,371,60,20,_xpl_stonline);
   xplPB.QPLcost = fl_add_button(FL_NORMAL_BUTTON,218,371,60,20,_xpl_stcost);
   xplPB.QPLyear = fl_add_lightbutton(FL_PUSH_BUTTON,280,371,60,20,_xpl_styear);

   xplPB.QPLsnapfr = fl_add_frame(FL_DOWN_FRAME,348,369,94,24,"");
   xplPB.QPLsnapshot = fl_add_button(FL_NORMAL_BUTTON,350,371,90,20,_xpl_snapshot);

  fl_end_form();
      
  fl_show_form(xplPB.form,FL_PLACE_CENTER,FL_TRANSIENT,_xpl_wintitle);
      
  xplPB.ready=0;
  while (xplPB.ready == 0)
    {
      xplPB.obj = fl_do_forms();

      /* ---------- left panel ---------- */
      /* begin month */
      if (xplPB.obj == xplPB.QPLmontham)
        {
          if (calmontha == 1)
            {
              calmontha = 12;
            }
          else
            {
              calmontha=calmontha-1;
            }
          calclear(0);
          callena = monthLen(calmontha,caljeara);
          fl_addto_form(xplPB.form);
          caldaya = docal(0,caldaya,calmontha,caljeara);
          fl_end_form();
          fl_set_object_label(xplPB.QPLmontha,month[calmontha-1]);
        }
      if (xplPB.obj == xplPB.QPLmonthap)
        {
          if (calmontha == 12)
            {
              calmontha = 1;
            }
          else
            {
              calmontha=calmontha+1;
            }   
          calclear(0);
          callena = monthLen(calmontha,caljeara);
          fl_addto_form(xplPB.form);
          caldaya = docal(0,caldaya,calmontha,caljeara);
          fl_end_form();
          fl_set_object_label(xplPB.QPLmontha,month[calmontha-1]);
        }

      /* begin year */ 
      if (xplPB.obj == xplPB.QPLjeara)
        {
          caljeara = int(fl_get_counter_value(xplPB.QPLjeara));
          calclear(0);
          callena = monthLen(calmontha,caljeara);
          fl_addto_form(xplPB.form);
          caldaya = docal(0,caldaya,calmontha,caljeara);
          fl_end_form();
        }

      /* From Calendar */
      for (a=1 ; a<=callena ; a++)
        {
          if (xplPB.obj == xplPB.QPLcala[a])
            {
              fl_set_object_color(xplPB.QPLcala[caldaya],FL_COL1,FL_MCOL);
              xplPB.ready=getDay(a,calmontha,caljeara);
              if ((xplPB.ready==0) || (xplPB.ready==6))
                {
                  fl_set_object_color(xplPB.QPLcala[a],FL_TOMATO,FL_BLUE);
                }
              else
                {
                  fl_set_object_color(xplPB.QPLcala[a],FL_SLATEBLUE,FL_BLUE);
                }
              xplPB.ready=0;
              caldaya=a;
            }
        }

      /* ---------- right panel ---------- */
      /* begin month */
      if (xplPB.obj == xplPB.QPLmonthbm)
        {
          if (calmonthb == 1)
            {
              calmonthb = 12;
            }
          else
            {
              calmonthb=calmonthb-1;
            }
          calclear(1);
          callenb = monthLen(calmonthb,caljearb);
          fl_addto_form(xplPB.form);
          caldayb = docal(1,caldayb,calmonthb,caljearb);
          fl_end_form();
          fl_set_object_label(xplPB.QPLmonthb,month[calmonthb-1]);
        }
      if (xplPB.obj == xplPB.QPLmonthbp)
        {
          if (calmonthb == 12)
            {
              calmonthb = 1;
            }
          else
            {
              calmonthb=calmonthb+1;
            }   
          calclear(1);
          callenb = monthLen(calmonthb,caljearb);
          fl_addto_form(xplPB.form);
          caldayb = docal(1,caldayb,calmonthb,caljearb);
          fl_end_form();
          fl_set_object_label(xplPB.QPLmonthb,month[calmonthb-1]);
        }

      /* begin year */ 
      if (xplPB.obj == xplPB.QPLjearb)
        {
          caljearb = int(fl_get_counter_value(xplPB.QPLjearb));
          calclear(1);
          callenb = monthLen(calmonthb,caljearb);
          fl_addto_form(xplPB.form);
          caldayb = docal(1,caldayb,calmonthb,caljearb);
          fl_end_form();
        }

      /* From Calendar */
      for (a=1 ; a<=callenb ; a++)
        {
          if (xplPB.obj == xplPB.QPLcalb[a])
            {
              fl_set_object_color(xplPB.QPLcalb[caldayb],FL_COL1,FL_MCOL);
              xplPB.ready=getDay(a,calmonthb,caljearb);
              if ((xplPB.ready==0) || (xplPB.ready==6))
                {
                  fl_set_object_color(xplPB.QPLcalb[a],FL_TOMATO,FL_BLUE);
                }
              else
                {
                  fl_set_object_color(xplPB.QPLcalb[a],FL_SLATEBLUE,FL_BLUE);
                }
              xplPB.ready=0;
              caldayb=a;
            }
        }

      /* calculation */
      if (xplPB.obj == xplPB.QPLcalc)
        {
          pbcalc();

          /* View Protocol */
          if ( (xplogs.PBView == 1) && (xplogs.PBProt == 1) )
            {
              fl_deactivate_form(xplPB.form);
              Viewcost();
              fl_activate_form(xplPB.form);
            }
        }

      /* Help */
      if (xplPB.obj == xplPB.QPLview)
        {
          fl_deactivate_form(xplPB.form);
          Viewcost();
          fl_activate_form(xplPB.form);
        }

      /* Exit */
      if (xplPB.obj == xplPB.QPLexit) 
        {
          xplPB.ready=1;      
        }


      /* View Statistic */
      if (xplPB.obj == xplPB.QPLstat)
        {
          if (statmode == 0)
            {
              /* Create Statistic File */
              /* create file path */
              strcpy(APuffer,xpuser);
              strcat(APuffer,"/.xplog.stat");
              strcpy(CPuffer,"");
              /* write into file */
              if ((fh=fopen(APuffer,"w"))!=NULL)
                {
                  for (b=1 ; b<=chartdays ; b++)
                    {
                      
                      strcpy(BPuffer,"   ");
                      if ((chartlab[b]==0) || (chartlab[b]==6))
                        {
                          strcpy(BPuffer,">> ");
                        }
                 
                      /* Onlinetime chartonl[b] */
                      strdef=strDiff(int(chartonl[b]));
                      strcpy(CPuffer,strdef);
                      if (strlen(CPuffer) == 7)
                        {
                          strcat(BPuffer," ");
                        }
                      strcat(BPuffer,CPuffer);
                      strcat(BPuffer," ");
                      
                      /* Cost chartdat[b] */
                      strdef = DoubleStr(chartdat[b]/100);
                      strcpy(CPuffer,"        ");
                      strcat(CPuffer,strdef);
                      strdef=strMids(CPuffer,strlen(CPuffer)-7,8);
                      strcat(BPuffer,strdef);
                      
                      strcat(BPuffer,"\n");
                      a=fputs(BPuffer,fh);
                      /*
                        if (chartlab[b]<100)
                        {
                        a=fputs(BPuffer,fh);
                        }
                      */
                    }
                  fclose(fh);
                  chmod(APuffer,S_IRUSR|S_IWUSR);
                  
                  fl_deactivate_form(xplPB.form);
                  Viewstat();
                  fl_activate_form(xplPB.form);
                }
            }
          if (statmode == 1)
            {
              fl_deactivate_form(xplPB.form);
              Viewsnap();
              fl_activate_form(xplPB.form);
              loadsnap();
              statistic(2);
            }
        }

      /* Online Statistic */
      if (xplPB.obj == xplPB.QPLonline) 
        {
          if (statmode == 0)
            {
              statistic(1);
            }
          if (statmode == 1)
            {
              statistic(3);
            }
        }
      /* Cost Statistic */
      if (xplPB.obj == xplPB.QPLcost) 
        {
          if (statmode == 0)
            {
              statistic(0);
            }
          if (statmode == 1)
            {
              statistic(2);
            }
        }

      /* SNAP-Mode */
      if (xplPB.obj == xplPB.QPLyear)
        {
          statmode = fl_get_button(xplPB.QPLyear);
          fl_set_button(xplPB.QPLyear,statmode);

          /* display Statistic */
          if (statmode == 0)
            {
              statistic(0);
            }
          if (statmode == 1)
            {
              /* ??? load SNAP-File */
              loadsnap();

              statistic(2);
            }
        }

      /* Snapshot */
      if (xplPB.obj == xplPB.QPLsnapshot)
        {
          /* Create Snapshot File */
          strcpy(APuffer,xpuser);
          strcat(APuffer,"/.xplog.snap");
          strcpy(CPuffer,"");
          /* write into file */
          if ((fh=fopen(APuffer,"ab"))!=NULL)
            {
              strcpy(BPuffer,"");
              /* Begin Date */
              strdef = IntStr(calmontha);
              strcpy(CPuffer,strdef);
              if (strlen(CPuffer)==1)
                {
                  strcat(BPuffer," ");
                }
              strcat(BPuffer,CPuffer);
              strcat(BPuffer,".");
              strdef = IntStr(caldaya);
              strcpy(CPuffer,strdef);
              if (strlen(CPuffer)==1)
                {
                  strcat(BPuffer," ");
                }
              strcat(BPuffer,CPuffer);
              strcat(BPuffer,".");
              strdef = IntStr(caljeara);
              strcpy(CPuffer,strdef);
              strcat(BPuffer,CPuffer);
              strcat(BPuffer," - ");
             
              /* End Date */
              strdef = IntStr(calmonthb);
              strcpy(CPuffer,strdef);
              if (strlen(CPuffer)==1)
                {
                  strcat(BPuffer," ");
                }
              strcat(BPuffer,CPuffer);
              strcat(BPuffer,".");
              strdef = IntStr(caldayb);
              strcpy(CPuffer,strdef);
              if (strlen(CPuffer)==1)
                {
                  strcat(BPuffer," ");
                }
              strcat(BPuffer,CPuffer);
              strcat(BPuffer,".");
              strdef = IntStr(caljearb);
              strcpy(CPuffer,strdef);
              strcat(BPuffer,CPuffer);
              strcat(BPuffer," ");

              /* Onlinetime - 14 digits */
              strcpy(CPuffer,"              ");
              strdef = strDiff(int(sponline));
              strcat(CPuffer,strdef);
              strdef = strMids(CPuffer,strlen(CPuffer)-13,14);
              strcat(BPuffer,strdef);
              strcat(BPuffer," ");

              /* Phonecosts - 14 digits */
              strcpy(CPuffer,"              ");
              strdef = DoubleStr(spcost/100);
              strcat(CPuffer,strdef);
              strdef = strMids(CPuffer,strlen(CPuffer)-13,14);
              strcat(BPuffer,strdef);

              strcat(BPuffer,"\n");
              a=fputs(BPuffer,fh);

              fclose(fh);
              chmod(APuffer,S_IRUSR|S_IWUSR);   
            }

          /* SNAP Mode */
          statmode=1;
          fl_set_button(xplPB.QPLyear,statmode);

          /* ??? load SNAP-File */
          loadsnap();

          /* display SNAP-Statistic */
          statistic(2);
        }

    }
      
  fl_hide_form(xplPB.form);

  /* load last Calc-Range */
  strcpy(APuffer,xpuser);
  strcat(APuffer,"/.xplog.range");
  /* read Calc-Range */
  if ((fh=fopen(APuffer,"w"))!=NULL)
    {   
      strdef = IntStr(caldaya);
      strcpy(BPuffer,strdef);
      strcat(BPuffer,"\n");
      a = fputs(BPuffer,fh);
      strdef = IntStr(calmontha);
      strcpy(BPuffer,strdef);
      strcat(BPuffer,"\n");
      a = fputs(BPuffer,fh);
      strdef = IntStr(caljeara);
      strcpy(BPuffer,strdef);
      strcat(BPuffer,"\n");
      a = fputs(BPuffer,fh);
      strdef = IntStr(caldayb);
      strcpy(BPuffer,strdef);
      strcat(BPuffer,"\n");
      a = fputs(BPuffer,fh);
      strdef = IntStr(calmonthb);
      strcpy(BPuffer,strdef);
      strcat(BPuffer,"\n");
      a = fputs(BPuffer,fh);
      strdef = IntStr(caljearb);
      strcpy(BPuffer,strdef);
      strcat(BPuffer,"\n");
      a = fputs(BPuffer,fh);
      fclose(fh);
      chmod(APuffer,S_IRUSR|S_IWUSR);
    }

  return;

}

/* calculation */
void pbcalc(void)
{
  const char *strdat;
  char AAS[256],BBS[256],CCS[255];

  /* for calculation protocol */
  /* String working */
  const char *sstrdef;
  char AAPuffer[256],BBPuffer[256],CCPuffer[256];
  int aaprot;
  /* Filehandle */
  FILE *fhh; 
  /* phonecosts */
  float protcost=0;

  /* Char Statistic Datas */
  fl_clear_chart(xplPB.chart);
  for (aaprot=1 ; aaprot<=93 ; aaprot++)
    {
      chartdat[aaprot]=0;
      chartlab[aaprot]=100;
      chartonl[aaprot]=0;
    }
  chartdays=daysBetwin(caldaya,calmontha,caljeara,caldayb,calmonthb,caljearb);
  chartflag=0;
  if (chartdays<=93)
    {
      chartlab[chartdays+1]=999;
      chartflag=1;
    }
 
  /* calc range */
  int calcb,calce;
  /* entry position */
  int calcbb;

  /* total cost time */
  float calccost=0;
  cityplus=0;
  int dayb,monthb,jearb,hourb,minb,secb;
  int daye,monthe,jeare,houre,mine,sece;  

  /* difference between two times */
  struct tm atm;
  time_t atime,btime;
  double difft=0;
  double diffs=0;

  /* loop flag */
  int ready;

  /* create begin and end time */
  calcb = (caljeara*10000)+(calmontha*100)+caldaya;
  calce = (caljearb*10000)+(calmonthb*100)+caldayb;

  /* create logfile path */
  strcpy(AAPuffer,xpuser);
  strcat(AAPuffer,"/.xplog.calculation");
  
  /* write into calculation protocal */
  if ((fhh=fopen(AAPuffer,"w"))!=NULL)
    {
      /* Protocol entry */
      strcpy(BBPuffer,_xpl_pbcprotocol);
      aaprot=fputs(BBPuffer,fhh);
      if (xplogs.PBProt==1)
        {
          strcpy(BBPuffer,_xpl_range);
          strcat(BBPuffer,IntStr(calmontha));
          strcat(BBPuffer,".");
          strcat(BBPuffer,IntStr(caldaya));
          strcat(BBPuffer,".");
          strcat(BBPuffer,IntStr(caljeara));
          strcat(BBPuffer," - ");
          strcat(BBPuffer,IntStr(calmonthb));
          strcat(BBPuffer,".");
          strcat(BBPuffer,IntStr(caldayb));
          strcat(BBPuffer,".");
          strcat(BBPuffer,IntStr(caljearb));
          strcat(BBPuffer,"\n\n");
          aaprot=fputs(BBPuffer,fhh);
          strcpy(BBPuffer,_xpl_pbcpline);
          aaprot=fputs(BBPuffer,fhh);
          strcpy(BBPuffer,"----------------------------------------------------------------------------------------------------\n");
          aaprot=fputs(BBPuffer,fhh);
        }
      if (xplogs.PBProt==0)
        {
          strcpy(BBPuffer,_xpl_pbcpremark);
          aaprot=fputs(BBPuffer,fhh);
        }

      /* begin calculation ? */
      fl_set_object_label(xplPB.viewfield,_xpl_pbcpscan); 
      if (calcb<=calce)
        {
          /* scan logfile */
          strcpy(AAS,xpuser);
          strcat(AAS,"/.xplog.log");
          /* read from logfile */
          if ((fh=fopen(AAS,"r"))!=NULL)
            {
              
              if (DEBUG == 1) cout << "xplog.log is open for read access...\n";
              
              ready=0;
              while (ready == 0)
                {
                  /* read logentry */
                  if (fgets(BBS,255,fh)!=NULL)
                    {
                      if (DEBUG == 1) cout << "log entry: " << BBS;
                    
                      /* delete linefeed */
                      memmove((BBS+strlen(BBS))-1,(BBS+strlen(BBS)),1);           
                      
                      /* Protocol entry */
                      strcpy(BBPuffer,BBS);
                      sstrdef=LStr(BBPuffer,60);
                      strcpy(BBPuffer,sstrdef);
                      
                      /* it's an xplog entry ? */
                      strdat = strMids(BBS,19,1);
                      strcpy(CCS,strdat);
                      if (strcmp(CCS,"-")==0)
                        {
                          /* entry position */
                          /* jear */
                          strdat = strMids(BBS,7,2);
                          strcpy(CCS,strdat);
                          calcbb = atoi(CCS);
                          if (calcbb>69)
                            {
                              calcbb=calcbb+1900;
                            }
                          else
                            {
                              calcbb=calcbb+2000;
                            }
                          calcbb=calcbb*10000;
                          /* month */
                          strdat = strMids(BBS,1,2);
                          strcpy(CCS,strdat);
                          calcbb = calcbb + (atoi(CCS)*100);
                          /* day */
                          strdat = strMids(BBS,4,2);
                          strcpy(CCS,strdat);
                          calcbb = calcbb + atoi(CCS); 
                          
                          /* is in calc-range ? */
                          if ((calcbb>=calcb) & (calcbb<=calce))
                            {
                              /* split entry into segments */
                              /* begin jear */
                              strdat = strMids(BBS,7,2);
                              strcpy(CCS,strdat);
                              jearb = atoi(CCS);
                              if (jearb>69)
                                {
                                  jearb=jearb+1900;
                                }
                              else
                                {
                                  jearb=jearb+2000;
                                }
                              /* begin month */
                              strdat = strMids(BBS,1,2);
                              strcpy(CCS,strdat);
                              monthb = atoi(CCS);
                              /* begin day */
                              strdat = strMids(BBS,4,2);
                              strcpy(CCS,strdat);
                              dayb = atoi(CCS); 
                              
                              /* end jear */
                              strdat = strMids(BBS,27,2);
                              strcpy(CCS,strdat);
                              jeare = atoi(CCS);
                              if (jeare>69)
                                {
                                  jeare=jeare+1900;
                                }
                              else
                                {
                                  jeare=jeare+2000;
                                }
                              /* end month */
                              strdat = strMids(BBS,21,2);
                              strcpy(CCS,strdat);
                              monthe = atoi(CCS);
                              /* end day */
                              strdat = strMids(BBS,24,2);
                              strcpy(CCS,strdat);
                              daye = atoi(CCS); 
                              
                              /* begin time */
                              strdat = strMids(BBS,10,2);
                              strcpy(CCS,strdat);
                              hourb = atoi(CCS);
                              strdat = strMids(BBS,13,2);
                              strcpy(CCS,strdat);
                              minb = atoi(CCS); 
                              strdat = strMids(BBS,16,2);
                              strcpy(CCS,strdat);
                              secb = atoi(CCS);
                              /* end time */
                              strdat = strMids(BBS,30,2);
                              strcpy(CCS,strdat);
                              houre = atoi(CCS); 
                              strdat = strMids(BBS,33,2);
                              strcpy(CCS,strdat);
                              mine = atoi(CCS);
                              strdat = strMids(BBS,36,2);
                              strcpy(CCS,strdat);
                              sece = atoi(CCS); 
                              
                              /* first time_t */
                              atm.tm_mday = dayb;
                              atm.tm_mon = monthb-1;
                              atm.tm_year = jearb-1900;
                              atm.tm_hour = hourb;
                              atm.tm_min = minb;
                              atm.tm_sec = secb;
                              atm.tm_isdst = -1;
                              atime = mktime(&atm);
                              /* second time_t */
                              atm.tm_mday = daye;
                              atm.tm_mon = monthe-1;
                              atm.tm_year = jeare-1900;
                              atm.tm_hour = houre;
                              atm.tm_min = mine;
                              atm.tm_sec = sece;
                              atm.tm_isdst = -1;
                              btime = mktime(&atm);
                              
                              /* Onlinezeit */
                              diffs = difftime(btime,atime);
                              difft = difft + diffs;
                              strdat = strDiff(int(difft));
                              strcpy(CCS,_xpl_pbcptime);
                              strcat(CCS,strdat);
                              strcat(CCS,_xpl_pbcpcosts);

                              /* Gebhr */
                              protcost=phonecalc(dayb,monthb,jearb,hourb,minb,secb,daye,monthe,jeare,houre,mine,sece);
                              calccost=calccost+protcost;
                              strdat = DoubleStr(calccost/100);
                              strcat(CCS,strdat);

                              /* CityPlus */
                              strcat(CCS," ( ");
                              strdat = DoubleStr(cityplus/100);
                              strcat(CCS,strdat);
                              strcat(CCS," [5:00 - 21:00])");

                              /* Chart Graphic */
                              if (chartflag==1)
                                {
                                  chartday=daysBetwin(caldaya,calmontha,caljeara,dayb,monthb,jearb);
                                  chartdat[chartday]=chartdat[chartday]+protcost;
                                  chartlab[chartday]=getDay(dayb,monthb,jearb);;
                                  chartonl[chartday]=chartonl[chartday]+diffs;
                                }

                              fl_set_object_label(xplPB.viewfield,CCS);
                              
                              /* Protocol entry */
                              if (DEBUG == 1) cout << "create protocol entry...";
                              if (xplogs.PBProt==1)
                                {
                                  /* Onlinetime */
                                  strcat(BBPuffer," ");
                                  strdat = strDiff(int(diffs));
                                  strcpy(CCPuffer,"            ");
                                  strcat(CCPuffer,strdat);
                                  strdat=strMids(CCPuffer,strlen(CCPuffer)-11,12);
                                  strcat(BBPuffer,strdat);
                                  strcat(BBPuffer," ");
                                  /* Costs */
                                  strdat = DoubleStr(protcost/100);
                                  strcpy(CCPuffer,"        ");
                                  strcat(CCPuffer,strdat);
                                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                                  strcat(BBPuffer,strdat);
                                  /* CityPlus */
                                  strcat(BBPuffer," ( ");
                                  if (protcity>0)
                                    {
                                      strdat = DoubleStr(protcity/100);
                                      strcpy(CCPuffer,"        ");
                                      strcat(CCPuffer,strdat);
                                    }
                                  else
                                    {
                                      strcpy(CCPuffer,"        ");  
                                    }
                                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                                  strcat(BBPuffer,strdat);
                                  strcat(BBPuffer," )\n");
                                  aaprot=fputs(BBPuffer,fhh);
                                  if (DEBUG == 1) cout << " protocol entry: " << BBPuffer << "\n";
                                }
     
                            }
                          else 
                            {
                            }
                        }
                      else
                        {
                          fl_set_object_label(xplPB.viewfield,""); 
                        }
                      
                    }
                  else
                    {
                      if (DEBUG == 1) cout << "close log read loop !!!\n";
                      ready=1;
                    }
                }

              /* Protocol entry */
              if (DEBUG == 1) cout << "complete protocol...\n"; 
              if (xplogs.PBProt==1)
                {
                  strcpy(BBPuffer,"----------------------------------------------------------------------------------------------------\n");
                  aaprot=fputs(BBPuffer,fhh);
              
                  /* Onlinetime */
                  strdat=LStr("",60);
                  strcpy(BBPuffer,strdat);
                  strcat(BBPuffer," ");
                  strdat = strDiff(int(difft));
                  strcpy(CCPuffer,"            ");
                  strcat(CCPuffer,strdat);
                  strdat=strMids(CCPuffer,strlen(CCPuffer)-11,12);
                  strcat(BBPuffer,strdat);
                  strcat(BBPuffer," ");
                  /* Costs */
                  strdat = DoubleStr(calccost/100);
                  strcpy(CCPuffer,"        ");
                  strcat(CCPuffer,strdat);
                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                  strcat(BBPuffer,strdat);
                  /* Cityplus */
                  strcat(BBPuffer," ( ");
                  strdat = DoubleStr(cityplus/100);
                  strcpy(CCPuffer,"        ");
                  strcat(CCPuffer,strdat);
                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                  strcat(BBPuffer,strdat);
                  
                  strcat(BBPuffer," )\n");
                  aaprot=fputs(BBPuffer,fhh);

                  strcpy(BBPuffer,"----------------------------------------------------------------------------------------------------\n");
                  aaprot=fputs(BBPuffer,fhh);

                  /* Basic Rates */
                  strcpy(BBPuffer,_xpl_pbcbrate);
                  strdat = DoubleStr(xplogs.xpbr);
                  strcpy(CCPuffer,"        ");
                  strcat(CCPuffer,strdat);
                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                  strcat(BBPuffer,strdat);
                  strcat(BBPuffer,"\n");
                  aaprot=fputs(BBPuffer,fhh);

                  /* Rent */
                  strcpy(BBPuffer,_xpl_pbcrent);
                  strdat = DoubleStr(xplogs.xprent);
                  strcpy(CCPuffer,"        ");
                  strcat(CCPuffer,strdat);
                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                  strcat(BBPuffer,strdat);
                  strcat(BBPuffer,"\n");
                  aaprot=fputs(BBPuffer,fhh);

                  /* Account  */
                  strcpy(BBPuffer,_xpl_pbccredit);
                  strdat = DoubleStr(xplogs.xpcredit);
                  strcpy(CCPuffer,"        ");
                  strcat(CCPuffer,strdat);
                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                  strcat(BBPuffer,strdat);
                  strcat(BBPuffer,"\n");
                  aaprot=fputs(BBPuffer,fhh);

                  strcpy(BBPuffer,"----------------------------------------------------------------------------------------------------\n");
                  aaprot=fputs(BBPuffer,fhh);

                  /* Costs */
                  strdat = LStr("",74);
                  strcpy(BBPuffer,strdat);
                  calccost = calccost + (xplogs.xpbr*100) + (xplogs.xprent*100) - (xplogs.xpcredit*100);
                  strdat = DoubleStr(calccost/100);
                  strcpy(CCPuffer,"        ");
                  strcat(CCPuffer,strdat);
                  strdat=strMids(CCPuffer,strlen(CCPuffer)-7,8);
                  strcat(BBPuffer,strdat);
                  strcat(BBPuffer,"\n");
                  aaprot=fputs(BBPuffer,fhh);

                  strdat=LStr("",60);
                  strcpy(BBPuffer,strdat);
                  strcat(BBPuffer," =======================================\n");
                  aaprot=fputs(BBPuffer,fhh);
                }
              fclose(fh);
              if (DEBUG == 1) cout << "protocol is closed !!!\n";
            }
          
        }
      else
        {
          /* dates are not correct */
        }
      
      if (difft == 0)
        {
          fl_set_object_label(xplPB.viewfield,""); 
        }

      /* Close Protocol */
      fclose(fhh);
      chmod(AAPuffer,S_IRUSR|S_IWUSR);
    
    }

  /* Onlinezeit */
  strdat = strDiff(int(difft));
  strcpy(CCS,_xpl_pbcptime);
  strcat(CCS,strdat);
  strcat(CCS,_xpl_pbcpcosts);
  /* Gebhr */
  strdat = DoubleStr(calccost/100);
  strcat(CCS,strdat);
  /* CityPlus */
  strcat(CCS," ( ");
  strdat = DoubleStr(cityplus/100);
  strcat(CCS,strdat);
  strcat(CCS," [5:00 - 21:00])");
  fl_set_object_label(xplPB.viewfield,CCS);

  /* Snapshot Datas */
  spcost = calccost;
  sponline = difft;

  /* Display Chart Graphic */
  if (chartflag==1)
    {
      /* SNAP Mode */
      statmode=0;
      fl_set_button(xplPB.QPLyear,statmode);
      statistic(0);
    }

  return;
}

int docal(int d,int c,int a,int b)
{
  int mlen;
  int x,y;
  struct tm atm;
  time_t atime;
  int aa,bb;

  mlen = monthLen(a,b);

  /* first dayname */
  atm.tm_mday = 1;
  atm.tm_mon = a-1;
  atm.tm_year = b-1900;
  atm.tm_hour = atm.tm_min = 0;
  atm.tm_sec = 1;
  atm.tm_isdst = -1;
  atime = mktime(&atm);
  if (d==0)
    {
      x = 10 + (atm.tm_wday*30);
    }
  else
    {
      x = 230 + (atm.tm_wday*30);
    }
  y = 62;

  for (aa=1 ; aa<=mlen ; aa++)
    {
      strdef=IntStr(aa);
      strcpy(APuffer,strdef);

      if (d == 0)
        {
          xplPB.QPLcala[aa] = fl_add_button(FL_NORMAL_BUTTON,x,y,30,20,APuffer);
        }
      else
        {
          xplPB.QPLcalb[aa] = fl_add_button(FL_NORMAL_BUTTON,x,y,30,20,APuffer);
        }

      x=x+30;
      if (x == 220)
        {
          y=y+20;
          x=10;
        } 
      if (x == 440)
        {
          y=y+20;
          x=230;
        } 
    }

  bb=c;
  if (bb>mlen)
    {
      bb=mlen;
    }

  if (d == 0)
    {
      fl_set_object_color(xplPB.QPLcala[bb],FL_SLATEBLUE,FL_BLUE);
    }
  else
    {
      fl_set_object_color(xplPB.QPLcalb[bb],FL_SLATEBLUE,FL_BLUE);
    }

  return(bb);
}

void calclear(int a)
{
  int aa;
  if (a == 0)
    {
      for (aa=1 ; aa<=callena ; aa++)
        {
          fl_hide_object(xplPB.QPLcala[aa]);
          fl_delete_object(xplPB.QPLcala[aa]);
        }
    }
  else
    {
      for (aa=1 ; aa<=callenb ; aa++)
        {
          fl_hide_object(xplPB.QPLcalb[aa]);
          fl_delete_object(xplPB.QPLcalb[aa]);
        } 
    }

  return;
}

void statistic(int a)
{
  int aa;

  fl_clear_chart(xplPB.chart);
  fl_set_object_label(xplPB.QPLstatframe,"");

  /* Calc-Range OK */
  if (chartflag==1)
    {

      /* Display Chart Graphic */
      if (a==0)
        {
          fl_set_object_label(xplPB.QPLstatframe,_xpl_pbcpcostatic);
          for (aa=1; aa<=chartdays; aa++)
            {
              if ((chartlab[aa]==0) || (chartlab[aa]==6))
                {
                  fl_add_chart_value(xplPB.chart,chartdat[aa],"",FL_TOMATO);
                }
              else
                {
                  fl_add_chart_value(xplPB.chart,chartdat[aa],"",FL_SLATEBLUE);
                }
            }
          
        }
      /* Display Chart Graphic */
      if (a==1)
        {
          fl_set_object_label(xplPB.QPLstatframe,_xpl_pbcponstatic);
          for (aa=1; aa<=chartdays; aa++)
            {
              if ((chartlab[aa]==0) || (chartlab[aa]==6))
                {
                  fl_add_chart_value(xplPB.chart,chartonl[aa],"",FL_TOMATO);
                }
              else
                {
                  fl_add_chart_value(xplPB.chart,chartonl[aa],"",FL_SLATEBLUE);
                }
            }
        }

    }
  /* Display SNAP-Chart Graphic */
  if (a==2)
    {
      fl_set_object_label(xplPB.QPLstatframe,_xpl_pbcpcostatic);
      for (aa=1; aa<=snapentrys; aa++)
        {
          fl_add_chart_value(xplPB.chart,snapcost[aa],"",FL_SLATEBLUE);
        }
    }
  /* Display SNAP-Chart Graphic */
  if (a==3)
    {
      fl_set_object_label(xplPB.QPLstatframe,_xpl_pbcponstatic);
      for (aa=1; aa<=snapentrys; aa++)
        {
          fl_add_chart_value(xplPB.chart,snaponline[aa],"",FL_SLATEBLUE);
        }
    }

 return;
}

/* load SNAP-File */
void loadsnap(void)
{

  /* loop flag */
  int ready;

  /* scan snapfile */
  strcpy(APuffer,xpuser);
  strcat(APuffer,"/.xplog.snap");
  /* read from snapfile */
  if ((fh=fopen(APuffer,"r"))!=NULL)
    {
      /* snapcost / snaponline */
      snapentrys=0;
      ready=0;
      while (ready == 0)
        {
          /* read logentry */
          if (fgets(BPuffer,255,fh)!=NULL)
            {
              snapentrys++;
              /* delete linefeed */
              memmove((BPuffer+strlen(BPuffer))-1,(BPuffer+strlen(BPuffer)),1);

              /* Online */
              strdef = strMids(BPuffer,25,8);
              strcpy(CPuffer,strdef);
              snaponline[snapentrys] = atof(CPuffer)*3600;
              strdef = strMids(BPuffer,34,2);
              strcpy(CPuffer,strdef);
              snaponline[snapentrys] = snaponline[snapentrys]+(atof(CPuffer)*60);
              strdef = strMids(BPuffer,37,2);
              strcpy(CPuffer,strdef);
              snaponline[snapentrys] = snaponline[snapentrys]+atof(CPuffer);
              /* Costs */
              strdef = strMids(BPuffer,40,14);
              strcpy(CPuffer,strdef);
              snapcost[snapentrys] = atof(CPuffer);
            }
          else
            {
              ready=1;
            }
        }      
      fclose(fh);
    }
}
